<template src="./template.html"/>
<style scoped src="./stylesheet.scss" lang="scss"/>

<script>
    import axios from 'axios';
    import { store } from "@/store/store";
    import VueUploadMultipleImage from 'vue-upload-multiple-image';
    import ShopForm from "../../../../components/ShopForm/ShopForm";
    import ContactForm from "../../../../components/ContactForm/ContactForm";

    // Importing validators
    import { required, email, minLength, sameAs } from 'vuelidate/lib/validators'

    export default {
        name: "ShopRegistration",
        components: {
            VueUploadMultipleImage,
            ShopForm,
            ContactForm
        },
        data() {
            // Controllo del valore delle variabili effettuato su createShop()
            return {
                email: null,
                confirmationEmail: null,
                password: null,
                confirmationPassword: null,
                shop: {
                    name: null,
                    description: null,
                    deliveryDetails: null,
                    deliveryConditions: null,
                    contacts: [], /* { "name": "string", "contactTypeId": 0} */
                    paymentTypesId: [],
                    categoryId: null,
                    city: 'Desenzano del Garda',
                    address: null,
                    primaryImageBase64: null,
                    imagesBase64: [],
                    contactNote: null   //  in old version: notes
                },

                shopFormState: true,

                tempImages: [],
                error: null,
                isButtonDisabled: false
            }
        },
        validations: {
            email: {
                required,
                email: email
            },
            confirmationEmail: {
                sameAs: sameAs('email'),
            },
            password: {
                required,
                minLen: minLength(6)
            },
            confirmationPassword: {
                required,
                sameAs: sameAs('password')
            }
        },
        computed: {
            buttonDisabled() {
                return this.$v.$invalid || this.shopFormState || this.isButtonDisabled;
            }
        },
        methods: {
            createShop() {
                this.isButtonDisabled = true;
                this.shop.primaryImageBase64 = null;
                this.shop.imagesBase64 = [];

                let imagesToSend = this.tempImages.slice();// Copy the array to a new one to edit it
                if(imagesToSend.length) {
                    this.shop.primaryImageBase64 = imagesToSend[0].path;
                    imagesToSend.splice(0, 1);
                    imagesToSend.forEach((image) => {
                        this.shop.imagesBase64.push(image.path);
                    });
                }

                // È possibile effettuare la richiesta
                axios({
                    method: "POST",
                    "url": "/account/register/business",
                    data: {
                        "account": {
                            "email": this.email,
                            "password": this.password
                        },
                        "store": this.shop
                    }
                }).then((response) => {
                    store.commit('authenticateUser', {
                        "id": response.data.id,
                        "email": response.data.email,
                        "storeId": response.data.storeId,
                        "storeName": response.data.storeName,
                        "accountTypeId": response.data.accountTypeId,
                        "token": response.data.token,
                        "tokenExpiration": response.data.tokenExpiration
                    });
                }).catch((error) => {
                    this.error = error.response.data.error;
                    this.$bvModal.show('error-modal');
                    this.isButtonDisabled = false;
                });
            },
            uploadImageSuccess(formData, index, fileList) {
                this.tempImages = fileList;
            },
            beforeRemove (index, done, fileList) {
                console.log('index', index, fileList);
                let r = confirm("remove image");
                if (r) {
                    done()
                }
            },
            editImage (formData, index, fileList) {
                console.log('edit data', formData, index, fileList)
            },
            clearForm() {
                this.shop.name = null;
                this.shop.description = null;
                this.shop.deliveryDetails = null;
                this.shop.deliveryConditions = null;
                this.shop.contacts = [];
                this.shop.paymentTypesId = [];
                this.shop.categoryId = null;
                this.shop.city = 'Desenzano del Garda';
                this.shop.address = null;
                this.shop.primaryImageBase64 = null;
                this.shop.imagesBase64 = [];
                this.shop.contactNote = null;

                this.tempImages = [];
                this.error = null;
            },
            userInput(value) {
                this.shopFormState = value;
            }
        }
    }
</script>
